﻿using System;
using System.Diagnostics.CodeAnalysis;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;

namespace AspNetCoreSerilogExample.Controllers
{
    [ApiController]
    [Route("log")]
    public class LogController : ControllerBase
    {
        private readonly ILogger<LogController> _logger;

        public LogController(ILogger<LogController> logger)
        {
            _logger = logger;
        }

        [HttpGet]
        [Route("test")]
        public async Task<IActionResult> TestAsync(CancellationToken ct = default)
        {
            var requestData = new RequestData();
            
            //_logger.LogInformation("Test message from {Controller} - DateTime.UtcNow = {NowUtc}", nameof(LogController), DateTime.UtcNow.ToString("O"));
            //_logger.LogInformation("requestData = {RequestData}", requestData);
            //_logger.LogInformation($"requestData = {requestData}");
            
            _logger.LogInformation("requestData = {@RequestData}", requestData);
            _logger.LogInformation("Property2 = {Property2}", requestData.Property2);
            
            return await Task.FromResult(Ok(new {Ok = true}));
        }
    }

    [SuppressMessage("ReSharper", "UnusedMember.Global")]
    internal class RequestData
    {
        public string Property1 { get; } = "test1";
        public int Property2 { get; } = new Random().Next(1, 10);
        public DateTime Timestamp { get; } = DateTime.UtcNow;

        //public override string ToString() => $"Property1='{Property1}' Property2='{Property2}' Timestamp='{Timestamp}'";
    }
}